from visual import *
# demonstration of vector cross product

scene.title="Vector Cross Product"
scene.width=600
scene.height=600
R = 0.15*4
plane = curve(pos=[(0, -10, -10), (0, -10, 10), (0, 10,10), (0, 10, -10),
              (0, -10, -10), (0,-6,-10), (0,-6,10), (0, -2, 10), (0, -2, -10),
              (0,2,-10), (0,2,10), (0,6,10), (0,6,-10),(0,10, -10),              
              (0,10,-6), (0,-10,-6), (0,-10,-2), (0,10,-2), (0,10,2),
              (0,-10,2), (0,-10,6), (0,10,6)])

s_theta=sphere(pos=(0,-12,-10), radius=0.6, color=(0.6, 1.0, 0.6))
s_theta.label="Fix Angle"
s_length=sphere(pos=(0,-12,10), radius=0.6, color=(0.6, 0.6, 1.0))
s_length.label="Fix Length"

s_text=sphere(pos=(0,12,5), radius=0.001, label="Yellow = Red x Green")
               
fixlength = 0
fixtheta = 0

avector = vector (0,0,-3.5)
bvector = vector (0,3,2)

a = arrow(pos=(0,0,0), axis=avector, shaftwidth=R, color=crayola.red)
b = arrow(pos=(0,0,0), axis=bvector, shaftwidth=R, color=crayola.green)

cvector = cross(avector,bvector)
c = arrow(pos=(0,0,0), axis=cvector, shaftwidth=R, color=crayola.yellow)

scene.autoscale = 0
scene.forward = (-1,-.5,-1)

print "Vector cross product:"
print "Red cross Green = Yellow"
print "Drag with mouse up to change green vector"
print "Rotate: right mouse button; Zoom, left mouse button"

while 1:
    while not scene.mouse.clicked:
        obs=scene.mouse.project(normal=(1,0,0), d=0)
        if not (obs==None):
            if not fixlength and not fixtheta:
                bvector = obs
                if bvector.mag > 20: bvector=bvector*(20/bvector.mag)
                b.axis=bvector
            elif fixlength:
                length=3.9
                bvector = length*norm(obs)
                b.axis=bvector
            elif fixtheta:
                length=mag(obs)
                bvector=length*norm(vector(0, .3, 1))
                b.axis=bvector

            cvector=cross(avector,b.axis)
            c.axis=cvector
        assert c.axis == cross(a.axis,b.axis)
        rate(50)
    scene.mouse.getclick()
    if scene.mouse.pick==s_length:
        if fixtheta:
            fixtheta = not(fixtheta)
            s_theta.color = (0.6, 1.0, 0.6)
        fixlength=not(fixlength)
        if fixlength:
            s_length.color=(0.0, 0.0, 1.0)
        else:
            s_length.color=(0.6, 0.6, 1.0)
    elif scene.mouse.pick==s_theta:
        if fixlength:
            fixlength = not(fixlength)
            s_length.color=(0.6, 0.6, 1.0)
        fixtheta = not(fixtheta)
        if fixtheta:
            s_theta.color=(0.0, 1.0, 0.0)
        else:
            s_theta.color = (0.6, 1.0, 0.6)
