from visual import *

print """
Drag with button up to show the magnetic field interactively.
Click to place a magnetic field vector made by the toroid.
"""

scene.width = 600
scene.height = 600
Rbig = 0.6
L = 2*pi*Rbig
Rsmall = 0.2
k = 1E-7 # mu-zero/4pi
I = 1.0
Ncoils = 20
Bscale = (2.*Rsmall)/(4*pi*1E-7*Ncoils*I/L)

dphi = 2.*pi/Ncoils/15.
phi = arange(0,2*pi+dphi,dphi)
helix=curve(x = Rbig*cos(phi)+Rsmall*cos(Ncoils*phi)*cos(phi),
            y = Rbig*sin(phi)+Rsmall*cos(Ncoils*phi)*sin(phi),
            z = -Rsmall*sin(Ncoils*phi))
helix.color = (1,0.7,0.2)
helix.radius = 0.01

delta = helix.pos[1:] - helix.pos[:-1]
center = (helix.pos[:-1] + helix.pos[1:])/2.
scene.range = 1.3*(Rbig+Rsmall)
vwidth = L/100

def BField(obs):
    r = obs-center
    rmag = mag(r)
    rmag.shape = (-1,1)
    return sum(k*I*cross(delta, r)/rmag**3)

# Wait for mouse to move into scene
while scene.mouse.pos is None: pass

obs = scene.mouse.pos
Bv = Bscale*BField(obs)
Bvector = arrow(pos=obs, axis=Bv, shaftwidth=vwidth, color=(0,1,1))

while 1:
    while not scene.mouse.clicked:
        if scene.mouse.pos != obs:
            obs = scene.mouse.pos
            Bvector.pos=obs
            Bvector.axis=Bscale*BField(obs)
        rate(50)

    obs = scene.mouse.getclick().pos
    Bv = Bscale*BField(obs)
    arrow(pos=obs, axis=Bv, shaftwidth=vwidth, color=(0,1,1))
