data list file='c:\Dli\c10micu.dat' /
       RECID         1-5
       UNIONTYP      6-6
       UNIONRNK      7-7
       DVCURUNN      8-8
       DVAGEDCC      9-11 (1)
       DVSEX        12-12
       DVUNAGE      13-15 (1)
       DVMSBEUN     16-16
       DVSPMSBE     17-17
       DVSPCOML     18-18
       DVAGEDIF     19-20
       DVCLMAR      21-21
       DVAGEMAR     22-24 (1)
       DVENDUNN     25-26
       DVAGESEP     27-29 (1)
       DVAGDTHC     30-32 (1)
       DVAGEDIV     33-35 (1)
       DVCHDEFF     36-36
       DVDURSEP     37-39 (1)
       DVDURDTH     40-42 (1)
       DVDURDIV     43-45 (1)
       DVDUREND     46-48 (1)
      .
Variable Labels
      RECID        'Record identification number'
      UNIONTYP     'Type of union'
      UNIONRNK     'Rank of union'
      DVCURUNN     'Current union/marriage'
      DVAGEDCC     'Age of respondent at time of survey'
      DVSEX        'Sex of respondent'
      DVUNAGE      'Age of respondent at beginning of union'
      DVMSBEUN     'Marital status of respondent before entering union'
      DVSPMSBE     'Marital status of sp./par. before entering union'
      DVSPCOML     'Sp./part. lived cl with someone else before union'
      DVAGEDIF     'Age difference between respondent and spouse/par.'
      DVCLMAR      'Spouse/partner and resp. lived cl before marriage'
      DVAGEMAR     'Age of resp. at beginning of marriage'
      DVENDUNN     'Marriage/common-law union ended in ....'
      DVAGESEP     'Age of resp. when last separation happened(mar/cl)'
      DVAGDTHC     'Age of resp. when union ended due to death of sp.'
      DVAGEDIV     'Age of respondent when marriage ended in divorce'
      DVCHDEFF     'Type of effect the divorce/sep. had on children'
      DVDURSEP     'Duration of union to last separation'
      DVDURDTH     'Duration of union to death of spouse'
      DVDURDIV     'Duration of union to divorce'
      DVDUREND     'Duration of union'.
Value Labels
     UNIONTYP 1 'MARRIAGE'
              2 'COMMON-LAW UNION THEN MARRIAGE'
              3 'COMMON-LAW UNION ONLY(NO MAR.)'/
     UNIONRNK 1 'FIRST UNION'
              2 'SECOND UNION'
              3 'THIRD UNION'
              4 'FOURTH UNION'
              5 'FIFTH UNION'
              6 'SIXTH UNION'
              7 'SEVENTH UNION'
              9 'NOT STATED'/
     DVCURUNN 1 'YES, MARRIAGE'
              2 'YES, COMMON-LAW UNION'
              3 'NO'/
     DVSEX    1 'MALE'
              2 'FEMALE'/
     DVUNAGE  99.6 'NOT STATED - PATH UNKNOWN'
              99.9 'NOT STATED'/
     DVMSBEUN 1 'WIDOWED'
              2 'DIVORCED'
              3 'SEPARATED'
              4 'SINGLE'
              6 'NOT STATED - PATH UNKNOWN'
              9 'NOT STATED'/
     DVSPMSBE 1 'WIDOWED'
              2 'DIVORCED'
              3 'SEPARATED'
              4 'SINGLE'
              9 'NOT STATED'/
     DVSPCOML 1 'YES'
              2 'NO'
              3 'DO NOT KNOW'
              9 'NOT STATED'/
     DVAGEDIF 1 'RESPONDENT 11+ YEARS OLDER'
              2 'RESPONDENT 6-10 YEARS OLDER'
              3 'RESPONDENT 5 YEARS OLDER'
              4 'RESPONDENT 4 YEARS OLDER'
              5 'RESPONDENT 3 YEARS OLDER'
              6 'RESPONDENT 2 YEARS OLDER'
              7 'RESPONDENT 1 YEAR OLDER'
              8 'RESPONDENT SAME AGE'
              9 'RESPONDENT 1 YEAR YOUNGER'
             10 'RESPONDENT 2 YEARS YOUNGER'
             11 'RESPONDENT 3 YEARS YOUNGER'
             12 'RESPONDENT 4 YEARS YOUNGER'
             13 'RESPONDENT 5 YEARS YOUNGER'
             14 'RESPONDENT 6-10 YEARS YOUNGER'
             15 'RESPONDENT 11+ YEARS YOUNGER'
             96 'NOT STATED - PATH UNKNOWN'
             99 'NOT STATED(SPOUSE AGE UNKNOWN)'/
     DVCLMAR  1 'YES' 2 'NO' 6 'NOT STATED - PAT UNKNOWN'
              7 'NOT APPLICABLE' 9 'NOT STATED'/
     DVAGEMAR 99.7 'NOT APPLICABLE' 
                         99.9  'NOT STATED' /
     DVENDUNN  1 'SEPARATION THEN DIVORCE/ANNUL.'
               2 'SEPARATION THEN DEATH OF SP.'
               3 'DEATH OF SPOUSE/PARTNER'
               4 'DIVORCE/ANNUL. WITHOUT SEPAR.'
               5 'MARRIAGE IS ONGOING'
               7 'SEPARATION FROM CURRENT SPOUSE'
               8 'COMMON-LAW UNION IS ONGOING'
              99 'NOT STATED'/
     DVAGESEP DVAGDTHC DVAGEDIV DVDURSEP DVDURDTH DVDURDIV
              99.6 'NOT STATED - PATH UNKNOWN'
              99.7 'NOT APPLICABLE'
              99.9 'NOT STATED'/
     DVCHDEFF 1 'VERY POSITIVE'
              2 'POSITIVE'
              3 'NEGATIVE'
              4 'VERY NEGATIVE'
              5 'NO EFFECT'
              6 'NOT STATED - PATH UNKNOWN'
              7 'NOT APPLICABLE'
              8 'NO CHILDREN AT TIME OF DIV/SEP'
              9 'NOT STATED'/
     DVDUREND 99.5 'SEPARATED BUT NOT DIVORCED'
              99.6 'NOT STATED - PATH UNKNOWN'
              99.7 'NOT APPLICABLE'
              99.9 'NOT STATED'.

Missing Values 
     unionrnk (9)
     dvunage (99.6,99.9)
     dvmsbeun (6,9)
     dvspmsbe (9)
     dvspcoml (3,9)
     DVAGEDIF (96,99)
     dvclmar (6,7,9)
     dvagemar (99.7,99.9)
     dvendunn (99)
     dvagesep DVAGDTHC DVAGEDIV DVDURSEP DVDURDTH DVDURDIV 
             (99.6,99.7,99.9)
     dvchdeff (6 thru highest)
     dvdurend (99.5 thru highest).
