#!/bin/sh
#@(#)mail2newswrapper %I% %E% %U%
#This script provides a unified/simplified interface to mail2news
#that catches errors so that sendmail won't bounce them back to the
#originator
trap "rm -f /tmp/A$$ /tmp/B$$; exit 0" 0 1 2 3 15

# May not be able to rely on innshellvars being readable.
#. /var/news/etc/innshellvars
NEWSMASTER=news
MAILCMD=/usr/ucb/mail

if [ X"$1" = 'X-d' ]
then
    debug="-."
    shift
fi


MAIL="${MAILCMD} -s '`/bin/uname -n` mail2news errors' ${NEWSMASTER}"
if [ -z "$1" ]
then
    /bin/echo "usage: $0 <group to inject>" >&2
    exit 1
fi

/bin/cat > /tmp/B$$
trace=/tmp/wrapper.trace
if [ -r $trace ]
then
    /bin/echo "/usr/news/bin/newsgate/mail2news.sh $1 <<\\\!***ENDOFINPUT" >> $trace
    /bin/cat /tmp/B$$ >> $trace
    /bin/echo "!***ENDOFINPUT" >> $trace
fi
/usr/news/bin/newsgate/mail2news $debug -a news@cunews.carleton.ca -o 'Carleton news gateway' -n $1 > /tmp/A$$ 2>&1 < /tmp/B$$
# JAS 980109 INN 1.7.2 we always get an error return so exit now
exit 0
if [ $? != 0 -o -s /tmp/A$$ ]
then
    (/bin/echo ""
    /bin/cat /tmp/A$$
    /bin/echo "\n============== Original Input ==============\n"
    /bin/cat /tmp/B$$
    ) | eval $MAIL
else
    :
fi
exit 0
