/*
    Authentication server.  Allows a client machine that has a clear
text password to crypt it before it is sent over the network connection to
the server.  Tested on SunOS and Solaris systems.

    Author: John Stewart

    Date: 961122

*/

#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef __SVR4
#include <shadow.h>
    struct spwd *spw;
#else
#include <pwd.h>
    struct passwd *pwp;
#endif __SVR4

void
main (int argc, char *argv[])
{
    char    iobuf[1024];
    char    buf[256];
    char    *p;
    char    user[8];
    char    epassword[32];
    char    target [32];
    int     rcode;

    setvbuf (stdout, iobuf, _IONBF, sizeof iobuf);

    /* client sends us "AUTHENTICATE: username" command */

    if (fgets (buf, sizeof buf, stdin) == NULL) exit (1);
    if (strncmp (buf, "AUTHENTICATE: ", 14)) exit (1);
    rcode = sscanf (buf + 14, "%8[^ \t\r\n]", user);
    if (rcode != 1) exit (1);

    /* return the two character password seed */

#ifdef __SVR4
    if ((spw = getspnam(user)) == NULL) {
        printf ("0\n");
        exit (1);
    }
    strncpy(target,spw->sp_pwdp, sizeof target);
#else  
    if ((pwp = getpwnam(user)) == NULL) {
        printf ("0\n");
        exit (1);
    }
    strncpy(target,pwp->pw_passwd, sizeof target);
#endif
    printf ("%c%c\n", target[0], target [1]);

    /* client sends encrypted password which should match the value in
       the password database */

    rcode = fscanf(stdin, "%13[^ \t\r\n]", epassword);
    if (rcode == 1 && strlen(epassword) == 13 && !strcmp(epassword,target))
        fprintf (stdout, "1\n");
    else
        fprintf (stdout, "0\n");
}
