
# line 2 "gag.y"
/*
**  GAG
**
**  Mail/news gateway alias generator.
*/
/* SUPPRESS 530 in yyparse *//* Empty body for statement */
/* SUPPRESS 593 on yyerrlab *//* Label was not used */
/* SUPPRESS 593 on yynewstate *//* Label was not used */
/* SUPPRESS 595 on yypvt *//* Automatic variable may be used before set */

#define MAINLINE
#include "gate.h"
#if	defined(RCSID)
static char RCS[] =
	"$Header: /nfs/papaya/u2/rsalz/src/newsgate/RCS/gag.y,v 1.8 91/07/18 11:04:03 rsalz Exp Locker: rsalz $";
#endif	/* defined(RCSID) */

#define EMPTY(p)		((p) == NULL || (p)[0] == '\0')

char		*Pname;			/* Program name			*/

int		Errors;			/* Did user screw up?		*/
STATIC int	NoGroupCheck;		/* Don't check if valid group?	*/
STATIC int	PostViaMail;		/* Make post-news-group alias?	*/
STATIC int	NewsStyle;		/* B or C news format?		*/
STATIC char	*OutDir;		/* Directory for BBN scripts	*/
STATIC FILE	*bbn;			/* File for BBN-style aliases	*/
STATIC FILE	*ppuser;		/* File for PP user aliases	*/
STATIC FILE	*ppshell;		/* File for PP shell aliases	*/
STATIC FILE	*mmdf;			/* File for MMDF aliases	*/
STATIC FILE	*sendmail;		/* File for Sendmail aliases	*/
STATIC FILE	*news;			/* File for sys file entries	*/

STATIC char	*CurDirectory,		*DefDirectory;
STATIC char	**CurDistribs,		**DefDistribs;
STATIC int	CurDoMailinglist,	DefDoMailinglist;
STATIC char	*CurFlags,		*DefFlags;
STATIC char	*CurMail2news,		*DefMail2news;
STATIC char	*CurMailcontact,	*DefMailcontact;
STATIC char	*CurMailhost,		*DefMailhost;
STATIC char	*CurModerator,		*DefModerator;
STATIC char	*CurNews2mail,		*DefNews2mail;
STATIC char	*CurOrganization,	*DefOrganization;
STATIC char	*CurOwner,		*DefOwner;
STATIC char	*CurRequestAddr,	*DefRequestAddr;
STATIC char	*CurSite,		*DefSite;
STATIC char	*CurUser,		*DefUser;

extern time_t	time();

# line 53 "gag.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
    char	*String;
    int		Bool;
} YYSTYPE;
# define tDEFAULT 257
# define tDIRECTORY 258
# define tDISTRIBUTIONS 259
# define tDOTIFY 260
# define tFALSE 261
# define tGATEWAY 262
# define tFLAGS 263
# define tID 264
# define tINEWS 265
# define tMAIL2NEWS 266
# define tMAILCONTACT 267
# define tMAILHOST 268
# define tMAILINGLIST 269
# define tMAILPOST 270
# define tMODERATOR 271
# define tNEWS2MAIL 272
# define tORGANIZATION 273
# define tOWNER 274
# define tREQUESTADDR 275
# define tSITE 276
# define tTRUE 277
# define tUSER 278

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 172 "gag.y"



/*
**  Copy the string s turning all '.' into '-'.
*/
STATIC char *
Dot2Dash(s)
    register char	*s;
{
    register char	*p;
    char		*save;

    for (save = p = COPY(s); *s; s++)
	*p++ = *s == '.' ? '-' : *s;
    *p = '\0';
    return save;
}


/*
**  Copy the string s putting a '.' before all uppercase letters and '.'.
*/
STATIC char *
Dotify(s)
    register char	*s;
{
    register char	*p;
    char		*save;

    for (save = p = NEW(char, strlen(s) * 2 + 1); *s; *p++ = *s++)
	if (*s == '.' || isupper(*s))
	    *p++ = '.';
    *p = '\0';
    return save;
}


/*
**  Check if the newsgroup exists in the ACTIVE file.
*/
STATIC int
ValidNewsgroup(Group)
    register char	*Group;
{
    static char		**File;
    register char	**p;
    register char	*q;

    if (NoGroupCheck)
	return TRUE;

    if (File == NULL)
	/* Read in active file, trim to just the newsgroup names. */
	for (p = File = ReadFile(ACTIVE); *p; p++)
	    if ((q = IDX(*p, ' ')) != NULL)
		*q = '\0';

    for (p = File; *p; p++)
	if (EQ(*p, Group))
	    return TRUE;

    Fprintf(stderr, "%s: ignoring invalid newsgroup \"%s\".\n", Pname, Group);
    return FALSE;
}


/*
**  Create a BBN alias set so that users can mail into a newsgroup
**  as if it were a mailing list.
*/
STATIC void
BBNpostviamail(Ngroup, GroupasMail)
    char		*Ngroup;
    char		*GroupasMail;
{
    register FILE	*F;
    char		buff[SM_SIZE];

    /* Create a post-news-group alias which pipes into
     * the /bin/dir/post-news-group script. */
    Fprintf(bbn, "post-%s: @%s { \"%s|%s/post-%s\" }\n",
	GroupasMail, CurMailhost, CurUser, CurDirectory, GroupasMail);
    Fprintf(bbn, "\tpost-%s@%s\n", GroupasMail, CurMailhost);

    /* Write a post-news-script which calls mail2news. */
    if (OutDir) {

	/* Open the file. */
	(void)sprintf(buff, "%s/post-%s", OutDir, GroupasMail);
	(void)unlink(buff);
	if ((F = fopen(buff, "w")) == NULL) {
	    Fprintf(stderr, "%s:  Can't open \"%s\" for output, %s.\n",
		Pname, buff, strerror(errno));
	    exit(1);
	}

	/* Write the script. */
	Fprintf(F, "#! /bin/sh\n");
	Fprintf(F, "## This script forwards into the \"%s\" newsgroup.\n",
	    Ngroup);
	Fprintf(F, "exec %s -n %s\n", CurMail2news, Ngroup);

	/* Close the file. */
	(void)fclose(F);
	(void)chmod(buff, 0755);
    }
}


/*
**  Write out one newsgroup/mailing list gatewaying entry.  This is where
**  the real work is done.  We do BBN, MMDF, Sendmail, and news/sys file
**  entries here.
*/
STATIC void
WriteOne(Ngroup, Mlist)
    register char	*Ngroup;
    register char	*Mlist;
{
    register char	**p;
    register FILE	*F;
    register char	*GroupasMail;
    char		buff[SM_SIZE];

    GroupasMail = Dot2Dash(Ngroup);

    if (bbn) {
	/* Create an alias that forwards to the script. */
	Fprintf(bbn, "\n##  Add this to the \"%s\" mailing list.\n", Mlist);
	Fprintf(bbn, "%s-gate: @%s { \"%s|%s/gate-%s\" }\n",
	    Mlist, CurMailhost, CurUser, CurDirectory, Mlist);
	Fprintf(bbn, "\t%s-gate@%s\n", Mlist, CurMailhost);

	/* Write the script. */
	if (OutDir) {
	    if (IDX(CurOrganization, '"')) {
		yyerror("Can't have \" in organization name");
		free(GroupasMail);
		return;
	    }

	    /* Open the file. */
	    (void)sprintf(buff, "%s/gate-%s", OutDir, Mlist);
	    (void)unlink(buff);
	    if ((F = fopen(buff, "w")) == NULL) {
		Fprintf(stderr, "%s:  Can't open \"%s\" for output, %s.\n",
		    Pname, buff, strerror(errno));
		exit(1);
	    }

	    /* Write it. */
	    Fprintf(F, "#! /bin/sh\n");
	    Fprintf(F, "## This script is on the \"%s\" mailing list.\n",
		Mlist);
	    Fprintf(F, "exec %s -n %s", CurMail2news, Ngroup);
	    if (!EMPTY(CurOrganization))
		fprintf(F, "\\\n\t-o \"%s\"", CurOrganization);
	    if (!EMPTY(CurModerator))
		Fprintf(F, "\\\n\t-a %s", CurModerator);
	    if (!EMPTY(CurFlags))
		Fprintf(F, " \\\n\t%s", CurFlags);
	    Fprintf(F, "\n");

	    /* Close it. */
	    (void)fclose(F);
	    (void)chmod(buff, 0755);
	}

	if (PostViaMail)
	    BBNpostviamail(Ngroup, GroupasMail);
    }

    if (sendmail || mmdf || ppshell || ppuser) {
	if (IDX(CurOrganization, '\'')) {
	    yyerror("Can't have ' in organization name");
	    free(GroupasMail);
	    return;
	}
	/* Does it make sense to do this? */
	if (!EMPTY(CurModerator) && CurDoMailinglist)
	    Fprintf(stderr, "Warning:  group %s is moderated and mailable.\n",
		Ngroup);
    }

    if (sendmail) {
	Fprintf(sendmail, "\n## %s <==> %s gateway\n", Ngroup, Mlist);
	Fprintf(sendmail, "%s%s: %s@%s\n",
	    CurDoMailinglist ? "" : "#", Mlist, Mlist, CurMailhost);
	if (!EMPTY(CurOwner))
	    Fprintf(sendmail, "%sowner-%s: %s\n",
		CurDoMailinglist ? "" : "#", Mlist, CurOwner);
	Fprintf(sendmail, "post-%s: \"|%s -n %s", Mlist, CurMail2news, Ngroup);
	if (!EMPTY(CurOrganization))
	    Fprintf(sendmail, " -o '%s'", CurOrganization);
	if (!EMPTY(CurFlags))
	    Fprintf(sendmail, " %s", CurFlags);
	if (!EMPTY(CurModerator))
	    Fprintf(sendmail, " -a %s", CurModerator);
	Fprintf(sendmail, "\"\n");
	if (!EMPTY(CurOwner))
	    Fprintf(sendmail, "owner-post-%s: %s\n", Mlist, CurOwner);

	if (PostViaMail) {
	    Fprintf(sendmail, "%s: \"|%s -n %s\"\n",
		GroupasMail, CurMail2news, Ngroup);
	    if (!EMPTY(CurOwner))
		Fprintf(sendmail, "owner-%s: %s\n", GroupasMail, CurOwner);
	}
    }

    if (mmdf) {
	Fprintf(mmdf, "\n## %s <==> %s gateway\n", Ngroup, Mlist);
	Fprintf(mmdf, "%s%s: %s@%s\n",
		CurDoMailinglist ? "" : "#", Mlist, Mlist, CurMailhost);
	Fprintf(mmdf, "post-%s: \"%s|%s -n %s",
	    Mlist, CurUser, CurMail2news, Ngroup);
	if (!EMPTY(CurOrganization))
	    Fprintf(mmdf, " -o '%s'", CurOrganization);
	if (!EMPTY(CurFlags))
	    Fprintf(mmdf, " %s", CurFlags);
	if (!EMPTY(CurModerator))
	    Fprintf(mmdf, " -a %s", CurModerator);
	Fprintf(mmdf, "\"\n");

	if (PostViaMail)
	    Fprintf(mmdf, "%s: \"%s|%s -n %s\"\n",
		GroupasMail, CurUser, CurMail2news, Ngroup);
    }

    if (ppuser) {
	Fprintf(ppuser, "\n## %s <==> %s gateway\n", Ngroup, Mlist);
	Fprintf(ppuser, "%s%s:822 %s@%s\n",
	    CurDoMailinglist ? "" : "#", Mlist, Mlist, CurMailhost);
	Fprintf(ppuser, "post-%s: shell\n", Mlist);
	if (PostViaMail)
	    Fprintf(ppuser, "%s:shell\n", GroupasMail);
	}  

    if (ppshell) {
	Fprintf(ppshell, "\n## %s <==> %s gateway\n", Ngroup, Mlist);
	Fprintf(ppshell, "post-%s:%s,,%s -n %s",
	    Mlist, CurUser, CurMail2news, Ngroup);
	if (!EMPTY(CurOrganization))
	    Fprintf(ppshell, " -o '%s'", CurOrganization);
	if (!EMPTY(CurFlags))
	    Fprintf(ppshell, " %s", CurFlags);
	if (!EMPTY(CurModerator))
	    Fprintf(ppshell, " -a %s", CurModerator);
	Fprintf(ppshell, "\n");
	if (PostViaMail)
	    Fprintf(ppshell, "%s:%s,,%s -n %s\n",
		GroupasMail, CurUser, CurMail2news, Ngroup);
    }  

    if (news == NULL) {
	/* Clean up. */
	free(GroupasMail);
	return;
    }

    if (CurSite == NULL) {
	Fprintf(stderr, "No site for newsgroup %s\n", Ngroup);
	return;
    }

    switch (NewsStyle) {

    case 'c':			/* C News	*/
	/* Psuedo-site name and distributions. */
	Fprintf(news, "%s\\\n  :%s,!%s.all/", CurSite, Ngroup, Ngroup);
	for (p = CurDistribs; *p; p++)
	    Fprintf(news, "%s%s", p == CurDistribs ? "" : ",", *p);
	Fprintf(news, "\\\n");

	/* Command invocation. */
	if (CurRequestAddr)
	    Fprintf(news, "  ::%s %s %s %s %s\n",
		    CurNews2mail, Mlist, CurMailcontact,
		    CurRequestAddr, CurMailhost);
	else
	    Fprintf(news, "  ::%s %s %s %s-request %s\n",
		    CurNews2mail, Mlist, CurMailcontact,
		    CurMailcontact, CurMailhost);
	break;

    case 'i':			/* InterNetNews	*/
	/* Psuedo-site name and distributions. */
	Fprintf(news, "%s\\\n  :%s/", CurSite, Ngroup);
	for (p = CurDistribs; *p; p++)
	    Fprintf(news, "%s%s", p == CurDistribs ? "" : ",", *p);
	Fprintf(news, "\\\n");

	/* Command invocation. */
	if (CurRequestAddr)
	    Fprintf(news, "  :Tp:%s %s %s %s %s %%s\n",
		    CurNews2mail, Mlist, CurMailcontact,
		    CurRequestAddr, CurMailhost);
	else
	    Fprintf(news, "  :Tp:%s %s %s %s-request %s %%s\n",
		    CurNews2mail, Mlist, CurMailcontact,
		    CurMailcontact, CurMailhost);
	break;

    case 'n':			/* B News	*/
	/* Psuedo-site name and distributions. */
	Fprintf(news, "%s\\\n  :", CurSite);
	for (p = CurDistribs; *p; p++)
	    Fprintf(news, "%s,!%s.all,", *p, *p);
	Fprintf(news, "%s,!%s.all\\\n ", Ngroup, Ngroup);

	/* Command invocation. */
	if (CurRequestAddr)
	    Fprintf(news, "  ::%s %s %s %s %s %%s\n",
		    CurNews2mail, Mlist, CurMailcontact,
		    CurRequestAddr, CurMailhost);
	else
	    Fprintf(news, "  ::%s %s %s %s-request %s %%s\n",
		    CurNews2mail, Mlist, CurMailcontact,
		    CurMailcontact, CurMailhost);
	break;
    }

    /* Clean up. */
    free(GroupasMail);
}


/*
**  Open a file, or use - for standard output.  Write the prolog.
*/
STATIC FILE *
openfile(name, timestring)
    char	*name;
    char	*timestring;
{
    FILE	*F;

    if (EQ(name, "-"))
	F = stdout;
    else if ((F = fopen(name, "w")) == NULL) {
	Fprintf(stderr, "%s:  Can't open \"%s\" for output, %s.\n",
		Pname, name, strerror(errno));
	exit(1);
    }

    /* Write prolog. */
    Fprintf(F, "##  %s\n", "--START-OF-GATEWAY-OUTPUT-");
    Fprintf(F, "##  Created at %s", timestring);
    Fprintf(F, "##  %s\n",
	"This section of the file has been built automatically.");
    Fprintf(F, "##  %s\n",
	"If you make any changes here they will be lost when it is rebuilt.");

    return F;
}


/*
**  Close a file, write the epilog.
*/
STATIC void
closefile(F)
    FILE	*F;
{
    if (F) {
	Fprintf(F, "##  %s\n", "--END-OF-GATEWAY-OUTPUT-");
	if (F != stdout)
	    (void)fclose(F);
    }
}


STATIC void
Usage()
{
    Fprintf(stderr, "Usage:\n\t%s %s\n\t\t%s input\n",
	    Pname,
	    "[-b] [-p] [-c cnews] [-n news] [-i inn_news] [-d dir]",
	    "[-b bbn] [-m mmdf] [-s sendmail] [-t PP_shell] [-u PP_user]");
    Fprintf(stderr, "Only one of -c or -n may be used.\n");
    exit(1);
}


int
main(ac, av)
    int		ac;
    char	*av[];
{
    int		c;
    time_t	now;
    char	*timestring;

    /* Set defaults. */
    if ((Pname = RDX(av[0], '/')) == NULL)
	Pname = av[0];
    else
	Pname++;
    now = time((time_t *)NULL);
    timestring = ctime(&now);

    /* Parse JCL. */
    while ((c = getopt(ac, av, "ab:c:i:m:n:ps:t:u:")) != EOF)
	switch (c) {
	default:
	    Usage();
	    /* NOTREACHED */
	case 'a':
	    NoGroupCheck = TRUE;
	    break;
	case 'b':
	    bbn = openfile(optarg, timestring);
	    break;
	case 'c':
	case 'i':
	case 'n':
	    if (NewsStyle)
		Usage();
	    NewsStyle = c;
	    news = openfile(optarg, timestring);
	    break;
	case 'd':
	    OutDir = optarg;
	    break;
	case 'm':
	    mmdf = openfile(optarg, timestring);
	    break;
	case 'p':
	    PostViaMail++;
	    break;
	case 's':
	    sendmail = openfile(optarg, timestring);
	    break;
	case 't':
	    ppshell = openfile(optarg, timestring);
	    break;
	case 'u':
	    ppuser = openfile(optarg, timestring);
	    break;
	}

    /* Get input. */
    ac -= optind;
    av += optind;
    if (ac != 0 && ac != 1)
	Usage();
    yyopen(av[0]);


    /* Do the work. */
    (void)yyparse();

    /* Close files. */
    closefile(bbn);
    closefile(mmdf);
    closefile(news);
    closefile(sendmail);
    closefile(ppuser);
    closefile(ppshell);

    /* That's all she wrote... */
    exit(Errors == 0 ? 0 : 1);
    return Errors == 0 ? 0 : 1;
}
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	262, 22,
	270, 22,
	-2, 0,
	};
# define YYNPROD 43
# define YYLAST 111
yytabelem yyact[]={

    49,    50,    86,    46,    29,    28,    72,    51,    52,    53,
    54,    55,    33,    56,    57,    58,    59,    60,    61,    12,
    62,    14,    15,     5,     7,    31,    67,    13,    16,    17,
    18,    19,    20,    30,    21,    22,    23,    24,    25,    26,
    64,    27,    66,    38,    63,    11,    10,     9,     8,    32,
    47,    34,    35,    36,    37,    39,    40,    41,    42,    43,
    44,    45,    87,    84,    48,     6,     4,    65,     3,     2,
     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    70,    71,     0,    73,    74,    75,     0,
    77,    78,    79,    80,    81,    82,    83,    68,     0,    69,
     0,     0,     0,     0,     0,     0,    85,     0,     0,     0,
    76 };
yytabelem yypact[]={

-10000000,  -233,   -11,   -12,   -13,   -14,  -243,  -237,-10000000,-10000000,
-10000000,-10000000,  -259,  -260,   -36,   -36,  -251,   -36,   -36,   -36,
   -18,   -36,   -36,   -36,   -36,   -36,   -36,   -36,  -261,  -258,
-10000000,  -220,-10000000,   -36,-10000000,-10000000,-10000000,-10000000,  -235,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -258,-10000000,  -258,   -36,
   -36,  -257,   -36,   -36,   -36,   -18,   -36,   -36,   -36,   -36,
   -36,   -36,   -36,-10000000,    23,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,   -36,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -262,-10000000,    21,-10000000 };
yytabelem yypgo[]={

     0,    33,    54,    70,    69,    68,    66,    65,    50,    64 };
yytabelem yyr1[]={

     0,     3,     3,     3,     3,     3,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     4,     6,     7,     8,     8,     9,     9,     9,     9,     9,
     9,     9,     9,     9,     9,     9,     9,     9,     9,     1,
     1,     2,     2 };
yytabelem yyr2[]={

     0,     0,     6,     6,     6,     6,     7,     7,     9,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
    11,     9,     1,     0,     4,     5,     5,     7,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
    11,     5,     5 };
yytabelem yychk[]={

-10000000,    -3,    -4,    -5,    -6,   256,    -7,   257,    59,    59,
    59,    59,   262,   270,   258,   259,   265,   266,   267,   268,
   269,   271,   272,   273,   274,   275,   276,   278,   264,   264,
    -1,    61,    -1,   263,    -1,    -1,    -1,    -2,    61,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   264,    -8,    -9,   258,
   259,   265,   266,   267,   268,   269,   271,   272,   273,   274,
   275,   276,   278,   264,   260,    -1,   277,   261,    -8,    -8,
    -1,    -1,   263,    -1,    -1,    -1,    -2,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    40,    -1,   264,    41 };
yytabelem yydef[]={

     1,    -2,     0,     0,     0,     0,     0,     0,     2,     3,
     4,     5,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    23,
     6,     0,     7,     0,     9,    10,    11,    12,     0,    13,
    14,    15,    16,    17,    18,    19,    23,    21,    23,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    39,     0,     8,    41,    42,    20,    24,
    25,    26,     0,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,     0,    27,     0,    40 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"tDEFAULT",	257,
	"tDIRECTORY",	258,
	"tDISTRIBUTIONS",	259,
	"tDOTIFY",	260,
	"tFALSE",	261,
	"tGATEWAY",	262,
	"tFLAGS",	263,
	"tID",	264,
	"tINEWS",	265,
	"tMAIL2NEWS",	266,
	"tMAILCONTACT",	267,
	"tMAILHOST",	268,
	"tMAILINGLIST",	269,
	"tMAILPOST",	270,
	"tMODERATOR",	271,
	"tNEWS2MAIL",	272,
	"tORGANIZATION",	273,
	"tOWNER",	274,
	"tREQUESTADDR",	275,
	"tSITE",	276,
	"tTRUE",	277,
	"tUSER",	278,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"file : /* empty */",
	"file : file block ';'",
	"file : file default ';'",
	"file : file mpost ';'",
	"file : file error ';'",
	"default : tDEFAULT tDIRECTORY value",
	"default : tDEFAULT tDISTRIBUTIONS value",
	"default : tDEFAULT tINEWS tFLAGS value",
	"default : tDEFAULT tMAIL2NEWS value",
	"default : tDEFAULT tMAILCONTACT value",
	"default : tDEFAULT tMAILHOST value",
	"default : tDEFAULT tMAILINGLIST boolean",
	"default : tDEFAULT tMODERATOR value",
	"default : tDEFAULT tNEWS2MAIL value",
	"default : tDEFAULT tORGANIZATION value",
	"default : tDEFAULT tOWNER value",
	"default : tDEFAULT tREQUESTADDR value",
	"default : tDEFAULT tSITE value",
	"default : tDEFAULT tUSER value",
	"block : op_init tGATEWAY tID tID op_set",
	"mpost : op_init tMAILPOST tID op_set",
	"op_init : /* empty */",
	"op_set : /* empty */",
	"op_set : an_opt op_set",
	"an_opt : tDIRECTORY value",
	"an_opt : tDISTRIBUTIONS value",
	"an_opt : tINEWS tFLAGS value",
	"an_opt : tMAIL2NEWS value",
	"an_opt : tMAILCONTACT value",
	"an_opt : tMAILHOST value",
	"an_opt : tMAILINGLIST boolean",
	"an_opt : tMODERATOR value",
	"an_opt : tNEWS2MAIL value",
	"an_opt : tORGANIZATION value",
	"an_opt : tOWNER value",
	"an_opt : tREQUESTADDR value",
	"an_opt : tSITE value",
	"an_opt : tUSER value",
	"value : '=' tID",
	"value : '=' tDOTIFY '(' tID ')'",
	"boolean : '=' tTRUE",
	"boolean : '=' tFALSE",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 6:
# line 75 "gag.y"
{ DefDirectory = yypvt[-0].String; } break;
case 7:
# line 76 "gag.y"
{ (void)Split(yypvt[-0].String, &DefDistribs, '\0'); } break;
case 8:
# line 77 "gag.y"
{ DefFlags = yypvt[-0].String; } break;
case 9:
# line 78 "gag.y"
{ DefMail2news = yypvt[-0].String; } break;
case 10:
# line 79 "gag.y"
{ DefMailcontact = yypvt[-0].String; } break;
case 11:
# line 80 "gag.y"
{ DefMailhost = yypvt[-0].String; } break;
case 12:
# line 81 "gag.y"
{ DefDoMailinglist = yypvt[-0].Bool; } break;
case 13:
# line 82 "gag.y"
{ DefModerator = yypvt[-0].String; } break;
case 14:
# line 83 "gag.y"
{ DefNews2mail = yypvt[-0].String; } break;
case 15:
# line 84 "gag.y"
{ DefOrganization = yypvt[-0].String; } break;
case 16:
# line 85 "gag.y"
{ DefOwner = yypvt[-0].String; } break;
case 17:
# line 86 "gag.y"
{ DefRequestAddr = yypvt[-0].String; } break;
case 18:
# line 87 "gag.y"
{ DefSite = yypvt[-0].String; } break;
case 19:
# line 88 "gag.y"
{ DefUser = yypvt[-0].String; } break;
case 20:
# line 91 "gag.y"
{
	    if (!Errors && ValidNewsgroup(yypvt[-2].String))
		WriteOne(yypvt[-2].String, yypvt[-1].String);
	} break;
case 21:
# line 97 "gag.y"
{
	    char	*GroupasMail;

	    if (!Errors && ValidNewsgroup(yypvt[-1].String)) {
		GroupasMail = Dot2Dash(yypvt[-1].String);
		if (bbn)
		    BBNpostviamail(yypvt[-1].String, GroupasMail);
		if (sendmail)
		    Fprintf(sendmail, "%s: \"|%s -n %s\"\n",
			GroupasMail, CurMail2news, yypvt[-1].String);
		if (mmdf)
		    Fprintf(mmdf, "%s: \"%s|%s -n %s\"\n",
			GroupasMail, CurUser, CurMail2news, yypvt[-1].String);
		if (ppuser)
		    Fprintf(ppuser, "%s:shell\n", GroupasMail);
		if (ppshell)
		    Fprintf(ppshell, "%s:%s,,%s -n %s\n",
			GroupasMail, CurUser, CurMail2news, yypvt[-1].String);
	    }
	} break;
case 22:
# line 119 "gag.y"
{
	    CurDoMailinglist = DefDoMailinglist;
	    CurDistribs = DefDistribs;
	    CurDirectory = DefDirectory;
	    CurFlags = DefFlags;
	    CurMail2news = DefMail2news;
	    CurMailhost = DefMailhost;
	    CurMailcontact = DefMailcontact;
	    CurModerator = DefModerator;
	    CurNews2mail = DefNews2mail;
	    CurOrganization = DefOrganization;
	    CurOwner = DefOwner;
	    CurRequestAddr = DefRequestAddr;
	    CurSite = DefSite;
	    CurUser = DefUser;
	} break;
case 25:
# line 141 "gag.y"
{ CurDirectory = yypvt[-0].String; } break;
case 26:
# line 142 "gag.y"
{ (void)Split(yypvt[-0].String, &CurDistribs, '\0'); } break;
case 27:
# line 143 "gag.y"
{ CurFlags = yypvt[-0].String; } break;
case 28:
# line 144 "gag.y"
{ CurMail2news = yypvt[-0].String; } break;
case 29:
# line 145 "gag.y"
{ CurMailcontact = yypvt[-0].String; } break;
case 30:
# line 146 "gag.y"
{ CurMailhost = yypvt[-0].String; } break;
case 31:
# line 147 "gag.y"
{ CurDoMailinglist = yypvt[-0].Bool; } break;
case 32:
# line 148 "gag.y"
{ CurModerator = yypvt[-0].String; } break;
case 33:
# line 149 "gag.y"
{ CurNews2mail = yypvt[-0].String; } break;
case 34:
# line 150 "gag.y"
{ CurOrganization = yypvt[-0].String; } break;
case 35:
# line 151 "gag.y"
{ CurOwner = yypvt[-0].String; } break;
case 36:
# line 152 "gag.y"
{ CurRequestAddr = yypvt[-0].String; } break;
case 37:
# line 153 "gag.y"
{ CurSite = yypvt[-0].String; } break;
case 38:
# line 154 "gag.y"
{ CurUser = yypvt[-0].String; } break;
case 39:
# line 157 "gag.y"
{
	    yyval.String = yypvt[-0].String;
	} break;
case 40:
# line 160 "gag.y"
{
	    yyval.String = Dotify(yypvt[-1].String);
	} break;
case 41:
# line 165 "gag.y"
{
	    yyval.Bool = TRUE;
	} break;
case 42:
# line 168 "gag.y"
{
	    yyval.Bool = FALSE;
	} break;
# line	532 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

