#!/usr/local/bin/perl

package Multiple_Choice;

&main'handle( 'CHOICES', 'help', '&Multiple_Choice\'doChoices' );
&main'handle( 'ANSWER', 'ans help', '&Multiple_Choice\'doAnswer' );
&main'handle( 'RESPONSES', '--', '&Multiple_Choice\'doResponses' );

#### Output all lines in the CHOICES section.  Markup each CHOICE
#### with the supplied ANS (label) - default label to oridinal # if
#### ANS not given.  Remember the answer that is marked CORRECT.

sub doChoices {
    local(*chattr) = @_;
    local($num,$label,%attr);
    print "<HR>\n";
    print "Select one of the following choices:\n<UL>\n";
    while( <main'IN> ) {
        last if m|^\s*<\s*/CHOICES\s*>|i;
        if( &main'isElement( 'CHOICE', *attr, 'ans correct' ) ) {
            $num++;
            $label = $attr{'ans'} || $num;
            $main'correctAnswer = $label if $attr{'correct'};
			$main'answeredCorrectly = &isCorrect();
            print "<LI>";
            printf "<a href=\"%s?ans=%s\">%s)</a>", $main'url, $label, $label;
        }
        print;
    }
    if( $chattr{'help'} ) {
        printf "<LI><A HREF=\"%s\">?) Help!</A>\n", $chattr{'help'};
    }
    print "</UL>\n";
}

#### Handle <ANSWER ...> thing

sub doAnswer {
    local( *attr ) = @_;
    $main'correctAnswer = $attr{'ans'};
	$main'answeredCorrectly = &isCorrect();
    if( $attr{'help'} ) {
        printf "<P><A HREF=\"%s\">Help</A> is available.\n", $attr{'help'};
    }
}

#### Handle the RESPONSES section.  If an answer was not supplied,
#### then skip everything.  Otherwise, analyze the WHEN clauses to
#### determine if any output is to be produced.  WHEN CORRECT and
#### WHEN INCORRECT lines are defaults to be output only if no other
#### lines have been.

sub doResponses {
	$answer = $main'answer;
	$isCorrect = $main'answeredCorrectly;
    print "<HR>\nYou chose answer $answer.<p>\n" if $answer;
    local($printing,$printed,%attr);
    while( <main'IN> ) {
        last if m|^\s*<\s*/RESPONSES\s*>|i;
        next if !$answer;
        if( &main'isElement( 'WHEN', *attr, 'ans correct incorrect' ) ) {
            $printing = 0;
            if( $attr{'ans'} ) {
                $printing = ($answer =~ /$attr{'ans'}/i ? 1 : 0);
            } elsif( $attr{'correct'} ) {
                $printing = $isCorrect && !$printed;
            } elsif( $attr{'incorrect'} ) {
                $printing = !$isCorrect && !$printed;
            }
        }
        ($printed = 1), print if $printing;
    }
    &main'defaultResponse() if $answer && !$printed;
	$main'responsePrinted = 1;
}

sub isCorrect { 
	$main'answer && ($main'answer eq $main'correctAnswer); 
}

1;
