#!/usr/local/bin/perl

package Single_Numeric;

&main'handle( 'ANSWER', 'ans tol eps help', '&Single_Numeric\'doAnswer' );
&main'handle( 'RESPONSES', '--', '&Single_Numeric\'doResponses' );

#### Handle <ANSWER ...> thing

sub doAnswer {
    local( *attr ) = @_;
    $answer = $main'answer;
    printf "<P><FORM METHOD=GET ACTION=\"%s\">\n", $main'url;
    printf "Answer: <INPUT TYPE=\"text\" NAME=\"ans\" MAXLENGTH=\"20\"";
    printf " VALUE=\"$answer\"" if $answer;
    printf ">\n";
    printf "<INPUT TYPE=\"submit\" VALUE=\"Submit Answer\">\n";
    printf "</FORM>\n";
    if( $attr{'help'} ) {
        printf "<P><A HREF=\"%s\"> Help</A> is available.\n", $attr{'help'};
    }
    $main'correctAnswer = $attr{'ans'};
    $tolerance = defined($attr{'tol'}) ? $attr{'tol'} : 0.001;
    $epsilon = defined($attr{'eps'}) ? $attr{'eps'} : -1;
	$main'answeredCorrectly = &isCorrect( $answer );
}


#### Handle the RESPONSES section.  If an answer was not supplied,
#### then skip everything.  Otherwise, analyze the WHEN clauses to
#### determine if any output is to be produced.  WHEN CORRECT and
#### WHEN INCORRECT lines are defaults to be output only if no other
#### lines have been.

sub doResponses {
	$answer = $main'answer;
    print "<HR>\nYour answer was: $answer<p>\n" if $answer;
    local($printing,$printed,%attr);
    while( <main'IN> ) {
        last if m|^\s*<\s*/RESPONSES\s*>|i;
        next if !$answer;
        if( &main'isElement( 'WHEN', *attr, 'ans expr correct incorrect' ) ) {
            $printing = 0;
            if( $attr{'ans'} ) {
                $printing = &isEqual($answer,$attr{'ans'});
            } elsif( $attr{'expr'} ) {
                $printing = &evalExpr( $attr{'expr'} );
            } elsif( $attr{'correct'} ) {
                $printing = 1 if $main'answeredCorrectly && !$printed;
            } elsif( $attr{'incorrect'} ) {
                $printing = 1 if !$main'answeredCorrectly && !$printed;
            }
            print "<p>" if $printing;
        }
        ($printed = 1), print if $printing;
    }
    &main'defaultResponse( &isCorrect($answer) ) if $answer && !$printed;
	$main'responsePrinted = 1;
}

sub isCorrect {
    local( $ans ) = @_;
    $ans && &isClose( &Eval($ans), &Eval($main'correctAnswer), $tolerance, $epsilon );
}

%funs = ( 'atan2',2,  'cos',1,  'exp',1,  'log',1,  'sin',1,  'sqrt',1 );

sub fmap { $funs{@_[0]} ? @_[0] : ''; }
    
sub Eval {
    local( $expr ) = @_;
    $expr =~ s/([A-Za-z][A-Za-z0-9]*)/&fmap($1)/eg;
    local( $result );
    $result = eval $expr;
    return $@ ? $expr : $result;
}	

sub isEqual {
    local( $ans1, $ans2 ) = @_;
    $ans1 == $ans2;
}

# compare two floating point values for almost equality

sub abs { local($n) = @_; return $n >= 0.0 ? $n : -$n; }
sub max { local($a,$b) = @_; return $a >= $b ? $a : $b; }

sub isClose {
    local( $a, $b, $tol, $eps ) = @_;
    return &abs( $a - $b ) <= $eps if $eps >= 0;
    &abs( $a - $b ) <= &abs($tol * $b);
}

sub evalExpr {
    local( $e ) = @_;
    $e =~ s/([a-z][a-z0-9]*)/$main'query{$1}/eg;
    local( $rc );
    $rc = eval $e;
#   print "$e => $rc\n";
    return $rc;
}

1;


