#!/usr/local/bin/perl

package True_False;

&main'handle( 'ANSWER', 'ans help', '&True_False\'doAnswer' );
&main'handle( 'RESPONSES', '--', '&True_False\'doResponses' );

#### Handle <ANSWER ...> thing

sub doAnswer {
    local( *attr ) = @_;
    printf "<P>The answer is:\n<OL>\n";
    printf "<LI><A HREF=\"%s?ans=true\">True</A>, or\n", $main'url;
    printf "<LI><A HREF=\"%s?ans=false\">False.</A>\n", $main'url;
    printf "</OL>\n";
    if( $attr{'help'} ) {
        printf "<P><A HREF=\"%s\">Help</A> is available.\n", $attr{'help'};
    }
    $main'correctAnswer = $attr{'ans'};
	$main'answeredCorrectly = &isCorrect( $main'answer );
}


#### Handle the RESPONSES section.  If an answer was not supplied,
#### then skip everything.  Otherwise, analyze the WHEN clauses to
#### determine if any output is to be produced.  WHEN CORRECT and
#### WHEN INCORRECT lines are defaults to be output only if no other
#### lines have been.

sub doResponses {
	$answer = $main'answer;
    print "<HR>\nYour answer was: $answer<p>\n" if $answer;
    local($printing,$printed,%attr);
    while( <main'IN> ) {
        last if m|^\s*<\s*/RESPONSES\s*>|i;
        next if !$answer;
        if( &main'isElement( 'WHEN', *attr, 'ans correct incorrect' ) ) {
            $printing = 0;
            if( $attr{'ans'} ) {
                $printing = &isEqual($answer,$attr{'ans'});
            } elsif( $attr{'correct'} ) {
                $printing = $main'answeredCorrectly && !$printed;
            } elsif( $attr{'incorrect'} ) {
                $printing = !$main'answeredCorrectly && !$printed;
            }
            print "<p>" if $printing;
        }
        ($printed = 1), print if $printing;
    }
    &main'defaultResponse() if $answer && !$printed;
	$main'responsePrinted = 1;
}

sub isCorrect {
    local( $ans ) = @_;
    $ans && &isEqual( $ans, $main'correctAnswer );
}

sub isEqual {
    local( $ans1, $ans2 ) = @_;
    $ans1 eq $ans2;
}

1;


